Subscribe / Connect / Follow Widget
===================================

A [WordPress](https://wordpress.org/) widget that displays image links (icon buttons) to various subscription services and social networking sites in your sidebar (or any widget holder). Helps users in easily finding links to subscription services like RSS feed, email subscriptions, podcast, etc., follow the website's Facbeook and Twitter pages, etc., and connect via various social networking sites.


Features
--------

* More than 40 services supported
* The widget can display upto 5 links at a time, though this number can be extended easily (see other notes).
* Output format for the links can be one of these five:
	* 32px images (default) 
	* 24px images 
	* 16px images
	* text links with image
	* text links.
* Other widget options include
	* Widget title
	* Option to select an alignment for images
	* Option to open the links in new window
	* Number of items *(new in 1.0)*
* Multiple instances of the widget can be had at the same time
* Uses WP_Widget class


Supported subscription services and social sites
------------------------------------------------

* Behance *(new in 1.0)*
* Blogger Blog
* Delicious
* Diaspora
* Digg
* deviantART
* Dribbble
* Email *(new in 1.0)*
* Etsy
* Facebook
* Feedburner Email Subscription
* Feedburner Feed
* Flickr
* Foursquare *(new in 1.0)*
* FriendFeed
* GitHub
* Goodreads
* Google Profile
* Google Plus
* identi.ca
* Instagram
* Last.fm
* LinkedIn
* Myspace
* Picasa Web Albums
* Pinterest
* Podcast
* Posterous
* Quora
* reddit
* RSS Feed
* RSS Feed for Posts
* RSS Feed for Comments
* Skype *(new in 1.0)*
* Slashdot
* SlideShare
* SoundCloud
* StumbleUpon
* Technorati
* Tumblr
* Twitter
* Vimeo
* WordPress.org Profiles
* WordPress.com Blog
* XING
* YouTube


Installation
------------

**Method 1**

1. Go to *Plugins -> Add New* in your WordPress admin area
1. Type 'subscribe connect follow widget' in the search box available and hit the 'Enter' key
1. Locate the 'Subscribe / Connect / Follow Widget' plugin authored by Srini G, and click 'Install Now'

**Method 2**

1. Dowload the latest version of the plugin from WordPress plugin directory
1. Go to *Plugins -> Add New* in your WordPress admin area
1. Click on the 'Upload Plugin' button at the top, near 'Add Plugins'
1. Browse and select the zip file you just downloaded, and click 'Install Now'

**Method 3**

1. Dowload the latest version of the plugin from WordPress plugin directory
1. Extract the zip file
1. Using a FTP client or something similar, upload the `subscribe-connect-follow-widget` directory to the `~/wp-content/plugins/` directory of your WordPress installation.

After installation, the plugin can be activated from *Plugins -> Installed Plugins* in your WordPress admin area. Once activated, the widget can be found and added from the *Widgets* menu.


Credits
-------

* The plugin uses [Social Media Icons](http://icondock.com/free/vector-social-media-icons) from IconDock.
* Diaspora icons by [CreativeKaizen](http://creativekaizen.deviantart.com/art/Diaspora-Icon-Set-257241499).
* Goodreads icons by [Paul Robert Lloyd](http://paulrobertlloyd.com/2009/06/social_media_icons/).


Links
-----

* [Plugin website](http://srinig.com/wordpress/plugins/subscribe-connect-follow-widget/)
* [Plugin at the WordPress plugin directory](https://wordpress.org/plugins/subscribe-connect-follow-widget/)
* [Support](https://wordpress.org/support/plugin/subscribe-connect-follow-widget)
* [Development at Github](https://github.com/sriniguna/subscribe-connect-follow-widget/)